Program Hanoi;                      { Tuerme von Hanoi }
{ 03.02.98: Umschreiben Zeichenroutine wegen Plattencrash und Verlust }
{ 04.02.98: Einfgen Keyboardroutine }


uses crt,graph,BGIDriv,BGIFont,drivers,Intuit,timer;

const imafils='hanoi.im';    { Hintergrundbild-Dateien }
      imastart='hanoia.im';  { Hintergrund Start-Screen }
      imaend='hanoib.im';    { Hintergrund End-Screen }
      turmfile='hanoit.ima'; { Turm / Masken }
      tmax=8;                { max. Turmhhe in Scheibenkleister }
      tmin=3;                { min. Turmhhe }
      deltax=128;            { Abstand der Trme }
      deltay=16;             { Scheibenhhe }
      xnull=193;             { x-Position 1.Turm }
      ynull=295;             { y-Position der Trme }

type intvector=array[0..tmax] of integer;   { 0: Anzahl, Rest:Elemente }
     intarray =array[0..2] of intvector;    { Zustandsarray der Trme }

var { Intuit-Structures: }
    ima          :array[1..24] of Image; { 1-8: Hintergrund, 9-16:Scheiben }
                                         { 17-24: Masken }
    xy1,xy2      :koords;                { Gadgets und ihre Verzierungen }
    ibord1,ibord2:array[1..5] of Border;
    itext1,itext2:array[1..5] of IntuiText;
    igad         :array[1..8] of Gadget;
    ch           :char;
    ende         :boolean;

{ ----------------------------------------------------------------- }
procedure abblenden;
var i:integer;
begin
   for i:=0 to 15 do SetPalette(i,i);            { sonst seltsame Effekte }
   for i:=15 downto 0 do SetRGBPalette(i,0,0,0);
end;

procedure aufblenden;
const pal : array[0..15,0..2] of word
          = (( 0, 0, 0),(14,30,30),(16,34,34),(18,39,39),
             (21,43,43),(23,48,48),(26,53,53),(47,22,18),
             (63,63,63),(59,24, 3),(63,48, 4),(52,38, 8),
             (41,30,10),(27,41,15),(11,21, 9),(63,58,42));
var i:integer;
begin
   for i:=0 to 15 do SetPalette(i,i);
   for i:=0 to 15 do SetRGBPalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure tuermeholen(var ok:boolean);
var i  :integer;
    f  :file;
    a,anz:word;
begin
assign(f,turmfile);
reset(f,1);
BlockRead(f,ima[1],sizeof(image),anz);
with ima[1] do begin
   anz:=Imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(f,p_data^,anz,a);
   ok:=a=anz;
   putimage(0,0,ima[1].p_data^,normalput);
   freemem(p_data,anz);
   p_nextimage:=nil;
end;
for i:=1 to 8 do begin
   with ima[i+8] do begin
      width:=80;
      height:=deltay;
      x:=-40;
      y:=0;
      p_nextimage:=nil;
      anz:=imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(width,(i-1)*deltay,pred(2*width),i*deltay-1,p_data^);
   end;
   with ima[i+16] do begin
      width:=80;
      height:=deltay;
      x:=-40;
      y:=0;
      p_nextimage:=nil;
      anz:=imagesize(1,1,width,height);
      getmem(p_data,anz);
      getimage(0,(i-1)*deltay,pred(width),i*deltay-1,p_data^);
   end;
end;
end;


procedure hintergrund(imadatei:string; var ok:boolean);
var i,size,anz: word;
    t         :string;
    f         :file;
    p         :pointer;
begin
   { Hintergrundbild laden: }
   size:=ImageSize(1,1,320,240);
   GetMem(p,size);
   for i:=1 to 4 do if ok then begin  { Malessen eines 16-bit Systems, }
      t:=imadatei+chr(48+i);           { 4 Durchgnge ntig wegen WORD! }
      Assign(f,t);
      {$i-}
      Reset(f,1);
      ok:=ok and (ioresult=0);
      {$i+}
      if ok then begin
         BlockRead(f,p^,size,anz);
         case i of
         1: PutImage(0,0,p^,NormalPut);
         2: PutImage(320,0,p^,NormalPut);
         3: PutImage(0,240,p^,NormalPut);
         4: PutImage(320,240,p^,NormalPut);
         end;
         close(f);
      end;
   end;
   FreeMem(p,size);
end;


procedure Startscreen(var ok:boolean);
var t:string;
begin
   hintergrund(imastart,ok);
   t:='T';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(76,40,t);
   Setcolor(8);
   outtextxy(78,42,t);
   Setcolor(11);
   outtextxy(80,44,t);
   outtextxy(81,45,t);
   outtextxy(82,46,t);

   SetTextStyle(gothicfont,horizdir,2);
   Setcolor(0);
   t:='ief in den Urwldern Hanois schichten die Mnche';
   outtextxy(128,88,t);
   t:='goldene Scheiben um von einem Ort des Tempels zu einem';
   outtextxy(80,120,t);
   t:='anderen. Da die Scheiben aus massivem Gold sehr';
   outtextxy(80,152,t);
   t:='schwer sind, darf keine grere auf einer kleineren';
   outtextxy(80,184,t);
   t:='Scheibe liegen. Haben die Mnche alle Scheiben um-';
   outtextxy(80,216,t);
   t:='geschichtet, so ist eine Sekunde der Ewigkeit vorbei!';
   outtextxy(80,248,t);

   t:='W';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(76,260,t);
   Setcolor(8);
   outtextxy(78,262,t);
   Setcolor(11);
   outtextxy(80,264,t);
   outtextxy(81,265,t);
   outtextxy(82,266,t);

   SetTextStyle(gothicfont,horizdir,2);
   Setcolor(0);
   t:='enn Du ihnen helfen willst, so whle die Scheibe';
   outtextxy(144,308,t);
   t:='mit der Maus, dann whle die Stelle, an der';
   outtextxy(80,340,t);
   t:='Du gedenkst, sie abzusetzen.';
   outtextxy(80,372,t);
   t:=' < Taste> ';
   outtextxy(480,400,t);
end;

procedure endscreen(var ok:boolean);
var t:string;
begin
   hintergrund(imaend,ok);
   t:='D';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(76,40,t);
   Setcolor(8);
   outtextxy(78,42,t);
   Setcolor(7);
   outtextxy(80,44,t);
   outtextxy(81,45,t);
   outtextxy(82,46,t);

   SetTextStyle(gothicfont,horizdir,2);
   Setcolor(0);
   t:='u hast Mhe und Arbeit auf Dich genommen und';
   outtextxy(128,88,t);
   t:='die Aufgabe bewltigt! Damit bist Du aufgenommen in';
   outtextxy(80,120,t);
   t:='die elitren Reihen der Computermnche, die in der';
   outtextxy(80,152,t);
   t:='Neuen Welt auch als Chip-Monks b.z.w. Chipmunks be-';
   outtextxy(80,184,t);
   t:='kannt und berhmt sind.';
   outtextxy(80,216,t);

   t:='D';
   SetTextStyle(gothicfont,horizdir,8);
   Setcolor(0);
   outtextxy(76,260,t);
   Setcolor(8);
   outtextxy(78,262,t);
   Setcolor(7);
   outtextxy(80,264,t);
   outtextxy(81,265,t);
   outtextxy(82,266,t);

   SetTextStyle(gothicfont,horizdir,2);
   Setcolor(0);
   t:='ieses Dokument wird jedem, dem Du es zeigst';
   outtextxy(128,308,t);
   t:='Deine Zugehrigkeit zu dieser Gruppe beweisen. Es ist';
   outtextxy(80,340,t);
   t:='maschinengeschrieben und ohne Unterschrift gltig!';
   outtextxy(80,372,t);
end;


procedure Playscreen(var ok:boolean);
var i:integer;
    t:string;
begin
   setcolor(0);
   hintergrund(imafils,ok);
   rectfill(0,0,639,15,1);
   SetTextStyle(gothicfont,horizdir,1);
   t:='T  r m e   v o n   H a n o i           UJa  V.2';
   Setcolor(0);
   outtextxy(192,-6,t);
   Setcolor(8);
   outtextxy(190,-6,t);
   Setcolor(10);
   outtextxy(191,-6,t);

{   SetTextStyle(DefaultFont,HorizDir,1);   }
   line(0,16,639,16);
   for i:=1 to 5 do DrawGadget(addr(igad[i]));
end;


procedure intuikram(var ok:boolean);
var i,size,anz:word;
    p         :pointer;
    f         :file;
    t         :string;
begin
   if ok then begin
      abblenden;
      hintergrund(imafils,ok);
{ Intuit-Strukturen initialisieren: }
      xy1[0]:=0;
      xy1[1]:=19;
      xy1[2]:=0;
      xy1[3]:=0;
      xy1[4]:=47;
      xy1[5]:=0;

      xy2[0]:=0;
      xy2[1]:=19;
      xy2[2]:=47;
      xy2[3]:=19;
      xy2[4]:=47;
      xy2[5]:=1;

      itext1[1].itext:='  + ';
      itext1[2].itext:='  - ';
      itext1[3].itext:='Neu ';
      itext1[4].itext:='Auto';
      itext1[5].itext:='Quit';

      for i:=1 to 5 do begin
         with ibord1[i] do begin
            x:=0;
            y:=0;
            fpen:=8;
            bpen:=6;
            drmode:=jam1;
            ecken:=3;
            p_ecken:=addr(xy1);
            p_nextborder:=addr(ibord2[i])
         end;
         ibord2[i]:=ibord1[i];
         ibord2[i].fpen:=1;
         ibord2[i].p_ecken:=addr(xy2);
         ibord2[i].p_nextborder:=nil;

         with itext1[i] do begin
            x:=8;
            y:=-4;
            fpen:=0;
            bpen:=14;
            drmode:=jam1;
            p_nexttext:=addr(itext2[i]);
         end;
         itext2[i]:=itext1[i];
         itext2[i].fpen:=15;
         itext2[i].x:=pred(itext1[i].x);
         itext2[i].p_nexttext:=nil;
      end;

      for i:=1 to 5 do with igad[i] do begin
         id:=i;
         x:=i*48;
         y:=460;
         width:=48;
         height:=20;
         bpen:=9;
         hibpen:=-1;
         p_loborder:=addr(ibord1[i]);
         p_hiborder:=p_loborder;
         p_loimage:=nil;
         p_hiimage:=nil;
         p_lointuitext:=addr(itext1[i]);
         p_hiintuitext:=p_lointuitext;
         gadgettyp:=boolgadget;
         onoff:=false;
         active:=true;
         p_specialinfo:=nil;
         p_nextgadget:=addr(igad[succ(i)]);
      end;
      for i:=1 to 5 do DrawGadget(addr(igad[i]));

      for i:=0 to 2 do with igad[i+6] do begin
         id:=i+6;
         x:=xnull+i*deltax-64;
         width:=deltax;
         y:=136;
         height:=184;
         bpen:=-1;
         hibpen:=-1;
         p_loborder:=nil;
         p_hiborder:=p_loborder;
         p_loimage:=nil;
         p_hiimage:=nil;
         p_lointuitext:=nil;
         p_hiintuitext:=p_lointuitext;
         gadgettyp:=boolgadget;
         onoff:=false;
         active:=true;
         p_specialinfo:=nil;
         if i<2 then p_nextgadget:=addr(igad[succ(i+6)])
                else p_nextgadget:=nil;
      end;

      { Images aus Screen pflcken }
      for i:=1 to tmax do with ima[i] do begin  { die leeren Images }
         width:=16+i*8;
         height:=16;
         x:=-(width div 2);
         y:=0;
         GetMem(p_data,imagesize(1,1,width,height));
         GetImage(321+x,151+height*i,320+x+width,150+height*succ(i),p_data^);
         p_nextimage:=nil;
      end;
   end;
end;


procedure cleanup;
var i    :integer;
begin
   for i:=1 to 2*tmax do with ima[i] do
   Freemem(p_data,imagesize(1,1,width,height));
end;

{$i hanoi3.inc }     { Zeichenroutinen, Automatik und Endcheck }

procedure auswertung(var nscheiben:integer; var p:intarray;
                     var fertig,ende:boolean);
var i,j,k,mx,my,id,oldpos:integer;
begin
id:=0;
while not (ende or fertig) do begin
   showmouse;
   delay1(50);
   ch:='.';
   k:=-1;
   while keypressed do ch:=readkey;
   if ch<>'.' then begin
      case ch of
      #27,'E','Q','e','q': k:=5;
      '+'                : k:=1;
      '-'                : k:=2;
      'A','a'            : k:=4;
      'N','n'            : k:=3;
      #49..#51           : k:=ord(ch)-43;
      end;

   end else getgadget(addr(igad[1]),k,mx,my);
   hidemouse;
   if k>0 then case k of
   1: begin
         if nscheiben<tmax then inc(nscheiben);
         initgame(nscheiben,p);
         id:=0;
      end;
   2: begin
         if nscheiben>tmin then dec(nscheiben);
         initgame(nscheiben,p);
         id:=0;
      end;
   3: begin
         initgame(nscheiben,p);
         id:=0;
      end;
   4: begin
         auto(nscheiben,p);
         delay1(1000);
         initgame(nscheiben,p);
      end;
   5: ende:=true;

6..8: begin
         i:=k-6;
         if id<1 then begin    {keine Scheibe gewhlt}
            id:=p[i,p[i,0]];
            if id>0 then begin
               markierescheibe(i,p);
               oldpos:=i;
            end;
         end else begin      {  Scheibe ist gewhlt, checken  }
            if (i<>oldpos) and (p[i,0]=0) or (p[i,p[i,0]]>id) then begin
               loeschescheibe(oldpos,p);
               setzescheibe(id,i,p);
               id:=0;
            end else begin  {Wahl rckgngig  }
               zeichnescheibe(id,oldpos,p);
               id:=0;
            end;
         end;
      end; { 6..8    }
   end; {  case       }
   fertig:=faehtich(p);
end;
end;




{ -------------------------------------------------------------------- }
{ === Main Prog === }

var fertig,ok      :boolean;
    pfosten        :intarray;
    nscheiben      :integer;

begin
initscreen(ok);
ende:=not ok;
if ok then begin
   tuermeholen(ok);
   intuikram(ok);
   startscreen(ok);
   aufblenden;
   ende:=readkey=#27;
   abblenden;
end;
if not ende then begin
   Playscreen(ok);
   nscheiben:=5;
   initgame(nscheiben,pfosten);
   aufblenden;
   repeat
      fertig:=false;
      auswertung(nscheiben,pfosten,fertig,ende);
      if fertig then begin
         delay1(1000);
         abblenden;
         endscreen(ok);
         aufblenden;
         while keypressed do ende:=readkey=#27;
         ende:=readkey=#27;
         if not ende then begin
            abblenden;
            playscreen(ok);
            initgame(nscheiben,pfosten);
            aufblenden;
         end;
      end;
   until ende;
   abblenden;
   cleanup;
end;
textmode(3);
end.
